Subject: go-sctp build failure: "protocol not supported"

From: Josh Holland <[email-masked]>
Date: Tue, 28 Apr 2020 13:15:34 +0100

Hi,

I was trying to install docker, which has go-sctp as a dependency.
However, it fails to build, with the following output:

$ guix build go-sctp
The following derivation will be built:
   /gnu/store/bc4sd2819gmy22dda1nhd179cacw7ny6-go-sctp-0.0.0-1.07191f8.drv
building /gnu/store/bc4sd2819gmy22dda1nhd179cacw7ny6-go-sctp-0.0.0-1.07191f8.drv...
starting phase `set-SOURCE-DATE-EPOCH'
phase `set-SOURCE-DATE-EPOCH' succeeded after 0.0 seconds
starting phase `set-paths'
environment variable `PATH' set to `/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/bin:/gnu/store/cnqpra8vr2l5fz00rr4yj4bp3hr00cfw-tar-1.32/bin:/gnu/store/py3k9zla9fj3z7430v4crqj5pyrsd3qj-gzip-1.10/bin:/gnu/store/l86azr7r3p5631wj3kk329jl1y1mpjgy-bzip2-1.0.6/bin:/gnu/store/lbip9isk25isymvnb159l115xnacb5j8-xz-5.2.4/bin:/gnu/store/6jdshxwdrad9mlhcqc9k0g24yw45rqf1-file-5.33/bin:/gnu/store/58sq8iabw3jkv0fvf95hd7sq2g4xcsnz-diffutils-3.7/bin:/gnu/store/v76scv4n63ip08g119rczh2mrw31zwpd-patch-2.7.6/bin:/gnu/store/g9d3wv1d68iflx57yp3mcp3k3sv8spsl-findutils-4.6.0/bin:/gnu/store/2z9hsww76aag37p40671l9niq5pvvasx-gawk-5.0.1/bin:/gnu/store/afmvfw1yhfal48n1kjq6bk6kcw8sc3db-sed-4.7/bin:/gnu/store/7iyvxhp2g3v3655zqwr6biz2h0lqv7pr-grep-3.3/bin:/gnu/store/9kzrrccpzl6i1sfwb0drb00gi2gwk0x0-coreutils-8.31/bin:/gnu/store/b5vpfzkr59bpgcsg1k9vvad9h5rwvpgk-make-4.2.1/bin:/gnu/store/29jhbbg1hf557x8j53f9sxd9imlmf02a-bash-minimal-5.0.7/bin:/gnu/store/nc5vlidpxbvngalng30nif8nb3j7gfy2-ld-wrapper-0/bin:/gnu/store/3hkdiscs4910r75njbrql10znxxn7chk-binutils-2.32/bin:/gnu/store/x3jx25cd3q363mr7nbgzrhrv1vza6cf7-gcc-7.4.0/bin:/gnu/store/ahqgl4h89xqj695lgqvsaf6zh2nhy4pj-glibc-2.29/bin:/gnu/store/ahqgl4h89xqj695lgqvsaf6zh2nhy4pj-glibc-2.29/sbin'
environment variable `BASH_LOADABLES_PATH' unset
environment variable `CPATH' set to `/gnu/store/l86azr7r3p5631wj3kk329jl1y1mpjgy-bzip2-1.0.6/include:/gnu/store/lbip9isk25isymvnb159l115xnacb5j8-xz-5.2.4/include:/gnu/store/6jdshxwdrad9mlhcqc9k0g24yw45rqf1-file-5.33/include:/gnu/store/2z9hsww76aag37p40671l9niq5pvvasx-gawk-5.0.1/include:/gnu/store/b5vpfzkr59bpgcsg1k9vvad9h5rwvpgk-make-4.2.1/include:/gnu/store/3hkdiscs4910r75njbrql10znxxn7chk-binutils-2.32/include:/gnu/store/x3jx25cd3q363mr7nbgzrhrv1vza6cf7-gcc-7.4.0/include:/gnu/store/ahqgl4h89xqj695lgqvsaf6zh2nhy4pj-glibc-2.29/include:/gnu/store/7czrqpi0kwazras6pgyx0bhdn89pg0jl-linux-libre-headers-4.19.56/include'
environment variable `LIBRARY_PATH' set to `/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/lib:/gnu/store/l86azr7r3p5631wj3kk329jl1y1mpjgy-bzip2-1.0.6/lib:/gnu/store/lbip9isk25isymvnb159l115xnacb5j8-xz-5.2.4/lib:/gnu/store/6jdshxwdrad9mlhcqc9k0g24yw45rqf1-file-5.33/lib:/gnu/store/2z9hsww76aag37p40671l9niq5pvvasx-gawk-5.0.1/lib:/gnu/store/3hkdiscs4910r75njbrql10znxxn7chk-binutils-2.32/lib:/gnu/store/ahqgl4h89xqj695lgqvsaf6zh2nhy4pj-glibc-2.29/lib:/gnu/store/qky1x5bb2jygy58bn6y95ygfsmpakf52-glibc-2.29-static/lib:/gnu/store/mmqp1xqffn6qw6v88i627c2bpbq36fcy-glibc-utf8-locales-2.29/lib'
environment variable `GUIX_LOCPATH' set to `/gnu/store/mmqp1xqffn6qw6v88i627c2bpbq36fcy-glibc-utf8-locales-2.29/lib/locale'
phase `set-paths' succeeded after 0.0 seconds
starting phase `install-locale'
using 'en_US.utf8' locale for category "LC_ALL"
phase `install-locale' succeeded after 0.0 seconds
starting phase `setup-go-environment'
phase `setup-go-environment' succeeded after 0.0 seconds
starting phase `unpack'
`/gnu/store/flhrga7qm4czsas6h0vd99wnydqxsgwh-go-sctp-0.0.0-1.07191f8-checkout/.gitignore' -> `/tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/src/github.com/ishidawataru/sctp/.gitignore'
`/gnu/store/flhrga7qm4czsas6h0vd99wnydqxsgwh-go-sctp-0.0.0-1.07191f8-checkout/.travis.yml' -> `/tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/src/github.com/ishidawataru/sctp/.travis.yml'
`/gnu/store/flhrga7qm4czsas6h0vd99wnydqxsgwh-go-sctp-0.0.0-1.07191f8-checkout/README.md' -> `/tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/src/github.com/ishidawataru/sctp/README.md'
`/gnu/store/flhrga7qm4czsas6h0vd99wnydqxsgwh-go-sctp-0.0.0-1.07191f8-checkout/sctp.go' -> `/tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/src/github.com/ishidawataru/sctp/sctp.go'
`/gnu/store/flhrga7qm4czsas6h0vd99wnydqxsgwh-go-sctp-0.0.0-1.07191f8-checkout/sctp_linux.go' -> `/tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/src/github.com/ishidawataru/sctp/sctp_linux.go'
`/gnu/store/flhrga7qm4czsas6h0vd99wnydqxsgwh-go-sctp-0.0.0-1.07191f8-checkout/sctp_streams_test.go' -> `/tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/src/github.com/ishidawataru/sctp/sctp_streams_test.go'
`/gnu/store/flhrga7qm4czsas6h0vd99wnydqxsgwh-go-sctp-0.0.0-1.07191f8-checkout/sctp_test.go' -> `/tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/src/github.com/ishidawataru/sctp/sctp_test.go'
`/gnu/store/flhrga7qm4czsas6h0vd99wnydqxsgwh-go-sctp-0.0.0-1.07191f8-checkout/sctp_unsupported.go' -> `/tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/src/github.com/ishidawataru/sctp/sctp_unsupported.go'
`/gnu/store/flhrga7qm4czsas6h0vd99wnydqxsgwh-go-sctp-0.0.0-1.07191f8-checkout/LICENSE' -> `/tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/src/github.com/ishidawataru/sctp/LICENSE'
`/gnu/store/flhrga7qm4czsas6h0vd99wnydqxsgwh-go-sctp-0.0.0-1.07191f8-checkout/example/sctp.go' -> `/tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/src/github.com/ishidawataru/sctp/example/sctp.go'
phase `unpack' succeeded after 0.0 seconds
starting phase `patch-usr-bin-file'
phase `patch-usr-bin-file' succeeded after 0.0 seconds
starting phase `patch-source-shebangs'
phase `patch-source-shebangs' succeeded after 0.0 seconds
starting phase `build'
WORK=/tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/go-build625703083
github.com/ishidawataru/sctp
mkdir -p $WORK/b001/
cat >$WORK/b001/importcfg << 'EOF' # internal
# import config
packagefile bytes=/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/pkg/linux_amd64/bytes.a
packagefile encoding/binary=/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/pkg/linux_amd64/encoding/binary.a
packagefile fmt=/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/pkg/linux_amd64/fmt.a
packagefile io=/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/pkg/linux_amd64/io.a
packagefile net=/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/pkg/linux_amd64/net.a
packagefile strconv=/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/pkg/linux_amd64/strconv.a
packagefile strings=/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/pkg/linux_amd64/strings.a
packagefile sync=/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/pkg/linux_amd64/sync.a
packagefile sync/atomic=/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/pkg/linux_amd64/sync/atomic.a
packagefile syscall=/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/pkg/linux_amd64/syscall.a
packagefile time=/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/pkg/linux_amd64/time.a
EOF
cd /tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/src/github.com/ishidawataru/sctp
/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/pkg/tool/linux_amd64/compile -o $WORK/b001/_pkg_.a -trimpath "$WORK/b001=>" -p github.com/ishidawataru/sctp -complete -buildid Q1r1L3qH3YHBCsR6toPz/Q1r1L3qH3YHBCsR6toPz -goversion go1.13.9 -D "" -importcfg $WORK/b001/importcfg -pack -c=4 ./sctp.go ./sctp_linux.go
/gnu/store/xacmln5jbjx28yb73cmp0v3i2g2wca8g-go-1.13.9/pkg/tool/linux_amd64/buildid -w $WORK/b001/_pkg_.a # internal
cp $WORK/b001/_pkg_.a /tmp/go-cache/2b/2b41bc8c58fa2521411ed8cef888fe3c64490889db0d340a488431d7592f521f-d # internal
mkdir -p /tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/pkg/linux_amd64/github.com/ishidawataru/
mv $WORK/b001/_pkg_.a /tmp/guix-build-go-sctp-0.0.0-1.07191f8.drv-0/pkg/linux_amd64/github.com/ishidawataru/sctp.a
rm -r $WORK/b001/
phase `build' succeeded after 0.3 seconds
starting phase `check'
--- FAIL: TestStreams (0.01s)
    sctp_streams_test.go:34: failed to listen: protocol not supported
--- FAIL: TestSCTPListenerName (0.00s)
    sctp_test.go:71: protocol not supported
--- FAIL: TestSCTPConcurrentAccept (0.00s)
    sctp_test.go:86: protocol not supported
--- FAIL: TestSCTPCloseRecv (0.00s)
    sctp_test.go:126: protocol not supported
FAIL
FAIL	github.com/ishidawataru/sctp	0.018s
FAIL
command "go" "test" "github.com/ishidawataru/sctp" failed with status 1
builder for `/gnu/store/bc4sd2819gmy22dda1nhd179cacw7ny6-go-sctp-0.0.0-1.07191f8.drv' failed with exit code 1
build of /gnu/store/bc4sd2819gmy22dda1nhd179cacw7ny6-go-sctp-0.0.0-1.07191f8.drv failed
View build log at '/var/log/guix/drvs/bc/4sd2819gmy22dda1nhd179cacw7ny6-go-sctp-0.0.0-1.07191f8.drv.bz2'.
guix build: error: build of `/gnu/store/bc4sd2819gmy22dda1nhd179cacw7ny6-go-sctp-0.0.0-1.07191f8.drv' failed

I am running Guix on top of a foreign distro (Arch); I looked up some
recent builds of go-sctp on the CI server, with rather mixed results.
Some have succeeded, some failed, some never attempted (due to missing
dependencies, I assume), and most seem to have the output cut off.

--
Josh Holland